HDU 5791:Two(DP)

http://acm.hdu.edu.cn/showproblem.php?pid=5791

Two

Problem Description

Alice gets two sequences A and B. A easy problem comes. How many pair of sequence A‘ and sequence B‘ are same. For example, {1,2} and {1,2} are same. {1,2,4} and {1,4,2} are not same. A‘ is a subsequence of A. B‘ is a subsequence of B. The subsequnce can be not continuous. For example, {1,1,2} has 7 subsequences {1},{1},{2},{1,1},{1,2},{1,2},{1,1,2}. The answer can be very large. Output the answer mod 1000000007.

Input

The input contains multiple test cases.

For each test case, the first line cantains two integers N,M(1≤N,M≤1000). The next line contains N integers. The next line followed M integers. All integers are between 1 and 1000.

Output

For each test case, output the answer mod 1000000007.

Sample Input

3 2

1 2 3

2 1

3 2

1 2 3

1 2

Sample Output

2

3

题意:有两个串,求两两子串相同的个数有多少(可以不连续)。

思路:有点类似于LCS的DP。

 1 #include <cstdio>
 2 #include <algorithm>
 3 #include <cstring>
 4 using namespace std;
 5 #define N 1005
 6 #define MOD 1000000007
 7 typedef long long LL;
 8
 9 LL dp[N][N];
10 int a[N], b[N];
11 /*
12 1 2 3
13 2 1
14 */
15 int main()
16 {
17     int n, m;
18     while(~scanf("%d%d", &n, &m)) {
19         dp[0][0] = 0;
20         for(int i = 1; i <= n; i++) {
21             scanf("%d", a+i);
22             dp[i][0] = 0;
23         }
24         for(int i = 1; i <= m; i++) {
25             scanf("%d", b+i);
26             dp[0][i] = 0;
27         }
28 /*
29 有这三部分
30 dp[i-1][j-1]
31 dp[i-1][j] - dp[i-1][j-1]
32 dp[i][j-1] - dp[i-1][j-1]
33 如果不匹配的话 dp[i][j] = dp[i-1][j] - dp[i-1][j-1] + dp[i][j-1] - dp[i-1][j-1] + dp[i-1][j-1]
34 匹配的话 dp[i][j] = 不匹配的状态 + dp[i-1][j-1] + 1
35 dp[i-1][j] + dp[i][j-1] - dp[i-1][j-1] 表示当前不匹配的状态有多少种,因为dp[i-1][j]和dp[i][j]中有dp[i-1][j-1]重复,所以要减去一个
36 如果当前匹配的话,就不用减去,因为要留一个来和当前的a[i]和b[j]匹配。
37 */
38         for(int i = 1; i <= n; i++) {
39             for(int j = 1; j <= m; j++) {
40                 if(a[i] == b[j]) {
41                     dp[i][j] = (dp[i-1][j] + dp[i][j-1] + 1 + MOD) % MOD;
42                 } else {
43                     dp[i][j] = (dp[i-1][j] + dp[i][j-1] - dp[i-1][j-1] + MOD) % MOD;
44                 }
45             }
46         }
47
48         printf("%I64d\n", dp[n][m] % MOD);
49     }
50     return 0;
51 }
时间: 2024-12-29 11:38:27

HDU 5791:Two(DP)的相关文章

HDU 1260:Tickets(DP)

Tickets Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 923    Accepted Submission(s): 467 Problem Description Jesus, what a great movie! Thousands of people are rushing to the cinema. However,

HDU 4745 Two Rabbits(DP)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4745 题意:n个数排成一个环.两个人AB初始时各自选定一个位置.每一轮A在顺时针方向选择一个位置,B在逆时针选择一个位置,且这两个人所选位置的数字相等,然后格子跳到新选的位置上.问最多进行多少轮?有一个限制为每次跳跃不能跨过以前自己曾经选过的格子. 思路:主要是分析问题的本质.其实就是求最长回文子列.f[i][j]为[i,j]的最长回文子列,则答案为max(f[1][i],f[i+1][n]). i

HDU 4833 Best Financing (DP)

Best Financing Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 29    Accepted Submission(s): 3 Problem Description 小A想通过合理投资银行理财产品达到收益最大化.已知小A在未来一段时间中的收入情况,描述为两个长度为n的整数数组dates和earnings,表示在第dat

hdu 1421 搬寝室 (dp)

思路分析: dp[i][j] 表示选取到第 i 个   组成了 j 对的最优答案. 当然排序之后 选取相邻两个是更优的. if(i==j*2) dp[i][j] = dp[i-2][j-1] + w[i]-w[i-2]^2.. else if( i> j*2 ) dp[i][j] = min (dp[i-2][j-1] + ...^2   ,    dp[i-1][j]).... #include <cstdio> #include <iostream> #include &

HDU 1159——Common Subsequence(DP)

Common Subsequence Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 23279    Accepted Submission(s): 10242 Problem Description A subsequence of a given sequence is the given sequence with some e

POJ 2192 :Zipper(DP)

恢复 DP一直以来都没怎么看,觉得很难,也只会抄抄模板和处理一些简单的背包.于是比赛出现了这道比较简单的题还是不会,要开始去学学DP了. 题意:给出3个字符串,分别为A串和B串还有C串,题目保证A的长度+B的长度=C的长度,C里面包含着A和B的字符,然后判断A和B在C里面的字符顺序还是不是和原来的A和B保持原样. 查看题目 做法:建立一个DP数组dp[i][j],第一维i表示使用了A的前i个字符,第二维j表示使用了B的前j个字符,然后赋予1或者0判断是否可以组成.如果此时c[i+j]==a[i]

Codeforces Gym101341K:Competitions(DP)

http://codeforces.com/gym/101341/problem/K 题意:给出n个区间,每个区间有一个l, r, w,代表区间左端点右端点和区间的权值,现在可以选取一些区间,要求选择的区间不相交,问最大的权和可以是多少,如果权和相同,则选区间长度最短的.要要求输出区间个数和选了哪些区间. 思路:把区间按照右端点排序后,就可以维护从左往右,到p[i].r这个点的时候,已经选择的最大权和是多少,最小长度是多少,区间个数是多少. 因为可以二分找右端点小于等于当前区间的左端点的某个区间

HDU 3237 Help Bubu(DP)

题目链接:点击打开链接 思路: 比赛时查一点出, 需要加一个优化才能防止超时(恶心), 状态很容易想到: d[i][j][s][k]表示前i本书拿了j本没拿的书的集合是s没拿的书的最后一本是k的最优解. 为什么状态压缩的是目前桌子上的书的集合呢?  因为我们要防止一种情况:那就是如果对于高度为H的一种书, 我们都拿走了, 那么还要放回桌子上, 最优解要+1, 这样表示之后, 我们只要判断一下有几种书桌子上没有就行了. 细节参见代码: #include <cstdio> #include <

HDU 4301 Divide Chocolate(DP)

http://acm.hdu.edu.cn/showproblem.php?pid=4301 题意: 有一块n*2大小的巧克力,现在某人要将这巧克力分成k个部分,每个部分大小随意,问有多少种分法. 思路: dp [ i ] [ j ] [ 0/1 ]表示到第 i 列时分成 j 块的方案数,0/1表示第 i 列的两格巧克力是否相连. 这样的话,分析到第 i 块时的情况如下: ①块数不变 dp[i][j][1] = dp[i][j][1] + dp[i-1][j][0]*2 dp[i][j][0]